#include <bios.h>
#include <dos.h>
#include <stdio.h>
#include <graphics.h>

union inkey { char ch[2]; int i; } c;

struct MOUSE_STATE {
 char buttons;     /*  ﭨ/樨    */
 int hor_position; /* p⠫쭠 p pp */
 int ver_position; /* p⨪쭠 p pp   */
} cur_state;

int MouseInit(void);
void ms_state(MOUSE_STATE *);
void ms_move(int, int);
//void vert_movement(int, int);
//void hor_movement(int, int);
void set_graph_cursor(int, int, unsigned int far *);
// int ms_release(MOUSE_STATE * );
// void scor_mouse(int scor_x,int scor_y);
void ms_shape(struct MOUSE_STATE *current_state);
#define  CURSOR_ON()       _AX=1; geninterrupt(0x33);
#define  CURSOR_OFF()      _AX=2; geninterrupt(0x33);

#define SHAPEBARS 2
static unsigned ms_mask[SHAPEBARS+1][32] =  {
 {  // AND-᪠ (᪠ p)
  0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
  0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
  // XOR-᪠ (᪠ pp)
  0x8000, 0xC000, 0xA000, 0x9000, 0xA800, 0xB400, 0xBA00, 0xBD00,
  0xBE80, 0xBF40, 0xBFA0, 0xBFD0, 0xBFE0, 0xAE00, 0xA300, 0xE300 }, // Arrow

 { 0x0000,0x2000,0x7000,0x7000,0x7600,0x7f60,0x7ff4,0x7ffe,
  0x7ffe,0x7ffe,0x3ffc,0x1ff8,0x0000,0x0ff0,0x0ff0,0x0000,
  0xdfff,0x8fff,0x07ff,0x01ff,0x009f,0x000b,0x0001,0x0000,
  0x0000,0x0000,0x8001,0xc003,0xe007,0xe007,0xe007,0xf007 }, // Hand

 {0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
  0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
  0x8000, 0x6e00, 0x5000, 0x2800, 0x5400, 0x4a00, 0x4500, 0x0280,
  0x0140, 0x00a0, 0x0050, 0x0028, 0x0014, 0x000a, 0x0005, 0x0002 }
 };

int ms_bar[SHAPEBARS][4]={
 {8,8,488,272},             // Field
 {520,8,632,292}            // Menu
};

///////////////////////////////////////////////////////////////
struct Item { char *Name; char Icon,Color; };
#define ICONS 40
struct Item scr[]= {
 {"Nothing",' ',0 },
 {"Ball",'o', 12 },
 {"Base",'',  10 },
 {"Murphy",'\002', 11},
 {"Infotron",'*',14},
 {"Processor",'', 7}, //LIGHTGRAY
 {"Block",'',15},  // WHITE
 {"Exit", 'E', 10},
 {"Orange disk",0x7f, 6},
 {"Right door",0x1a, 13},
 {"Down door",0x19, 13},
 {"Left door",0x1b, 13}, //LIGHTMAGENTA
 {"Up door",0x18, 13},
 {"Right door 2",0x1a, 5},
 {"Down door 2",0x19, 5},
 {"Left door 2",0x1b, 5}, //MAGENTA
 {"Up door 2",0x18, 5},
 {"Scissors",'X',12},
 {"Yellow disk", 0x7f, 14},
 {"Terminal",  'T', 15},
 {"Red disk", 0x7f, 12},
 {"Vert. door", 0x17, 13},
 {"Hor. door", 0x1d, 13},
 {"Cross door",0x23,13},
 {"Electron",'e', 12},
 {"Hide spark", '',  12},
 {"Chip 1",0x0f,9},
 {"Chip 2",0x0f, 10},
 {"Chip 3",0x0f, 11},
 {"Green lamp",'', 10},
 {"Blue lamp", '',  9},
 {"Red lamp",'', 12},
 {"Lines", '',14}, //YELLOW
 {"Diod 1",'H', 1},
 {"Condensator",'H', 2},
 {"Diod 2",'H', 3},
 {"Red diod",'H', 4},
 {"Yellow diod",'H', 5},
 {"Scheme 1",'H', 6},
 {"Scheme 2",'H', 7},
 {"\0",' ',0}
};

int initEGA (void); void Save_(void); void Message (int,int,char *);
void field (int); void list (int List_Pos);
void Write_Item (int i,int j); void Write_Level (int Level);
void itoa100 (int n, char *str); char ToUpper (char c); int atoi100 (char *str);
void Get_Int(int x1, int y1, char *String,int MaxLen);
void Out (int x1,int y1,char *String,int MaxLen,int Curs_Pos,char Cursor);
void ncpy (char *In, char *Out, int *Len);
//////////////////////////////////////////////////////////////

FILE *fp;
int Shape=SHAPEBARS,Level=1;
char Field[1440],Ch=0x00,Grav=0x00;
unsigned char Infotrons=0x00;
static char s[2]={' ','\0'};

void main (void) {
 const char *Name="levels.dat"; char *How="There are     infotrons";
 char PosStr[]={' ',' ',' ',' ',' ',' ','\0'};
 char press=0x00,Sym[2]={'\0','\0'}; int L=1,List_Pos=0,cx,cy,xpos,ypos; 
 static int oldxpos,oldypos;
 // File:
 fp=fopen (Name,"r+b");
 if (fp==NULL) {
  fprintf (stdout,"\a\nCan't open %s in current directory!",Name); return; }
 fseek (fp,0L,SEEK_SET);
 // Initialization:
 if (!initEGA()) {
  fprintf (stdout,"\a\nCan't initialize EGA graphics!"); return; }
 if (!MouseInit ()) {
  fprintf (stdout,"\a\nCan't detect mouse!"); return; }
 // Picture shape:
 Message  (12,314,"Left");
 Message  (12,326,"Right"); 
 setfillstyle (SOLID_FILL,LIGHTGRAY);
 const x0=375;
 bar (x0-4,299,639,348);
 setcolor (LIGHTBLUE);
 outtextxy (x0,300,"Supaplex Editor;  Nick Soft, 1996");
 setcolor (WHITE);
 outtextxy (x0,312,"\030,\031 1 Level   PgUp,PgDn 10 Levels");
 outtextxy (x0,324,"I Infotrons to collect  G Gravity");
 outtextxy (x0,336,"S Save   C Clear level  ESC  Quit");
 do { // Start editing...
  list(List_Pos); // List of Icons
  Level=L;        // We need to double level selection
  Infotrons=0x00; // Current number of infotrons
  field (Level); // Current level
  do { // Editing of current level...
   while (!bioskey(1)) {  // Key not pressed
    ms_state (&cur_state); // Read mouse position
    ms_shape (&cur_state); // and select mouse cursor' shape
    press=cur_state.buttons;
    cx=cur_state.hor_position; // Pixel positions
    cy=cur_state.ver_position;
    xpos=(cx-8)/8; ypos=(cy-8)/11; // Array positions
    if (press==0x01 || press==0x02) { // If mouse button pressed...
     if (Shape==0) { // ...in the main field
      Field[ypos*60+xpos]=Sym[press-1]; Ch=0x01;
      Write_Item (xpos,ypos); // then write current item for left or right button
     } 
     else if (Shape==1) { // ...in the list of icons
      if (cy>272) {
       if (cx<576) List_Pos=0;
       else List_Pos=24; // Select Up or Down
       list(List_Pos);
      }
      else {
       cy=(cy-8)/11+List_Pos; // Select new icon for left or right button
       Sym[press-1]=cy<ICONS?cy:0;
       Message (62,314,scr[Sym[0]].Name); // Change messages about current item
       Message (62,326,scr[Sym[1]].Name);
      }
     }
    }
    else { // Mouse not pressed
     if (Shape==0) { // Change messages about current selection
                     // if we are in field screen zone
      if (oldxpos!=xpos || oldypos!=ypos) { // if mouse position changed
       Message (10,290,scr[(Field[ypos*60+xpos])].Name);
       itoa100 (xpos+1,PosStr); itoa100 (ypos+1,&PosStr[3]);
       Message (10,278,PosStr);
      }
      oldxpos=xpos; oldypos=ypos;
     }
     else { Message (10,290,""); Message (10,278,""); }
    }
   }; // While not pressed any key
   c.i=bioskey (0); // Key pressed
   if (c.ch[0]) switch (ToUpper(c.ch[0])) { // Key pressed switch
    case 27: Save_();  closegraph(); return;
    case '': case 'S': Write_Level (Level); break; // Save
    case '': case 'C': // Clear level
     for (xpos=0; xpos<1440; xpos++) Field[xpos]=0x00; // Free space
     for (xpos=0; xpos<60; xpos++) Field[xpos]= Field[1439-xpos] =0x06; // Walls
     for (ypos=1; ypos<23; ypos++) Field[60*ypos] =Field[60*(ypos+1)-1] =0x06;
     for (ypos=0; ypos<24; ypos++) 
     for (xpos=0; xpos<60; xpos++) Write_Item (xpos,ypos); // Write in buffer
    Ch=0x01; break;
    case '': case 'G': // Gravity
     Grav^=0x01; // Switch gravity between 0 and 1 conditions
     if (Grav) Message (10,338,"Gravity ON");
     else Message (10,338,"Gravity OFF");
    break;
    case '': case 'I': // Infotrons counter
     Message (10,338,"Set number of infotrons: ");
     PosStr[3]='\0';
     Get_Int (210, 338, &PosStr[3], 3); // Get String
     Infotrons=atoi100(&PosStr[3]);
     itoa100(Infotrons,&How[10]);
     Message (10,338,How);
    break;
    default: break;
   }
   else switch (c.ch[1]) { // Change current level number
    case 72:  L++; break;
    case 80:  L--; break;
    case 73:  L+=10; break;
    case 81:  L-=10; break;
    default: break;
   }
  } while (L==Level); // While in Level
  if (L<1) L=1;
  if (L>111) L=111; // Level boards control
  Save_(); // Save changed level
 } while (1);
}

void Save_(void) {
 if (Ch) {
  Message (10,338,"Save this level on disk? (y/n)");
  for (;;) {
   c.i=bioskey(0);
   if (c.ch[0]=='y' || c.ch[0]=='Y') { 
    Write_Level (Level);  break; }
   else if (c.ch[0]=='n' || c.ch[0]=='N') {
    Message (10,338,""); Ch=0x00; break; }
  };
 } return;
}

void Message (int x,int y,char *str) {
 setfillstyle (SOLID_FILL,BLACK);
 bar (x, y, 300, y+11);
 setcolor (WHITE);
 outtextxy (x , y, str);
}

////////////////////////////////////////

void list (int List_Pos) {
 int i; 
 CURSOR_OFF();
 setfillstyle (SOLID_FILL,LIGHTGRAY);
 bar (512,0,639,296);
 setfillstyle (SOLID_FILL,BLACK);
 bar (520,8,632,272);
 setcolor (YELLOW);
 outtextxy (530, 276, "Up");
 outtextxy (580, 276, "Down");
 for (i=0; i<24 ; i++) {
  if (scr[List_Pos+i].Name[0]=='\0') break;
  s[0]=scr[List_Pos+i].Icon;
  setcolor (scr[List_Pos+i].Color);
  outtextxy (521,9+11*i,s);
  setcolor (WHITE);
  outtextxy (533,9+11*i,scr[List_Pos+i].Name);
 } CURSOR_ON();
}

void field ( int Level) {
 long Pos; int i,j; char *Lev="Level    ";
 CURSOR_OFF();setfillstyle (SOLID_FILL,LIGHTGRAY);
 bar (0,4,496,276);
 setfillstyle (SOLID_FILL,BLACK);
 bar (8,8,488,272);
 Pos=(Level-1L)*1536L;
 // FILE *fp is common file descriptor;
 fseek (fp,Pos,SEEK_SET);
 fread (&Field[0],1,1440,fp);
 for (i=0; i<24; i++) 
 for (j=0; j<60; j++) Write_Item (j,i);
 setcolor (WHITE);
 itoa100 (Level,&Lev[6]);
 Message (12,302,Lev);
 CURSOR_ON();
 return;
}

void itoa100 (int n, char *str) {
 str[0]=n>99 ? '1' : ' '; if (n>99) n-=100; 
 str[1]=n/10+'0'; str[2]=n%10+'0';
 return;
}

int atoi100 (char *str) {
 char *ptr=str; int ret=0,deg=1;
 while (*ptr) ptr++; ptr--;
 while (ptr>=str) {
  ret+=(*ptr-48)*deg;
  deg*=10; ptr--;
 }
 return (ret);
}

void Write_Item (int i,int j) {
 int xpos,ypos,k;
 xpos=8+i*8; ypos=8+j*11; k=Field[j*60+i];
 s[0]=scr[k].Icon; CURSOR_OFF();
 setfillstyle (SOLID_FILL,BLACK);
 bar (xpos,ypos,xpos+8,ypos+11);
 setcolor (scr[k].Color);
 outtextxy (xpos,ypos,s); CURSOR_ON();
 return;
}

void Write_Level (int Level) {
 long Pos; int i; unsigned char Infotrons_Pictured=0x00;
 Ch=0x00; // Changes losed after this function
 for (i=0; i<1440; i++) { 
  if (Field[i]==0x04) { // Infotron in the field found
   if (Infotrons_Pictured==255) { // Only 255 or less infotrons
    Message (10,338, "Too much infotrons -- can't be saved");
    return;
   }
   Infotrons_Pictured++;
  }
 }
 if (Infotrons) { //'I' pressed in Editor...
  // Compare number of current infotrons with input
  if (Infotrons>Infotrons_Pictured) Infotrons=Infotrons_Pictured;
 }
 Pos=(Level-1L)*1536L;
 fseek (fp,Pos,SEEK_SET);
 fwrite (&Field[0],1,1440,fp); 
 fseek (fp,Pos+1444L,SEEK_SET); fwrite (&Grav,1,1,fp); 
 fseek (fp,Pos+1470L,SEEK_SET); fwrite (&Infotrons,1,1,fp); 
 Message (10,338,"Level saved");
 return;
}

char ToUpper (char c) {
 if (c>96 && c<123 || c>159 && c<176) c-=32; // a-z, -
 else if (c>223 && c<240) c-=80; // -
 return (c);
}

//////     ࠡ⪨ ப
void Get_Int(int x1, int y1, char *String,int MaxLen) {
 int Curs_Pos=0,Len=0,i; char Cursor=0x00; char Strin[10];
 ncpy (Strin, String, &Len); Curs_Pos=Len;
 do {
  Strin[Len]='\0';
  Out (x1,y1,Strin,MaxLen,Curs_Pos,Cursor);
  c.i=bioskey (0);
  Out (x1,y1,Strin,MaxLen,Curs_Pos,Cursor);
  if (c.ch[0]) switch (c.ch[0]) {
   case '\r': ncpy (String, Strin,&Len); String[Len]='\0'; return;
   case 27: return;
   case 8: if (Len > 0) {
    if (Curs_Pos>0 && Curs_Pos<=Len) {
     for( i = Curs_Pos-1; i < Len-1; i++ ) Strin[i] = Strin[i+1];
      Len--; Curs_Pos--;
    } 
   }
   default: if (c.ch[0]>='0' && c.ch[0]<='9') { // Digit symbol
    if (Curs_Pos<=Len) {
     if (Cursor) { if (Len<=MaxLen) Strin[Curs_Pos]=c.ch[0]; }
     else if (Len<MaxLen){
      Len++; Curs_Pos++;
      for (i=Curs_Pos; i<Len; i++) Strin[i] = Strin[i-1];
      Strin[Curs_Pos-1]=c.ch[0];
     }
    }
    else Curs_Pos=Len;
   }
   break;
  }
  else switch (c.ch[1]) { // Change current level number
   case 75: if (Curs_Pos>0) Curs_Pos--; break;
   case 77: if (Curs_Pos<Len) Curs_Pos++; break;
   case 71: Curs_Pos=0; break;
   case 79: Curs_Pos=Len; break;
   case 83: if (Len > 0) {
    if (Curs_Pos>=0 && Curs_Pos<Len) {
     for( i = Curs_Pos; i < Len-1; i++ ) Strin[i] = Strin[i+1];
      Len--;
    } 
   }//Del
   break;
   case 82: Cursor^=0x01; break; //Ins
   default: break;
  }
 } while (1);
}

void Out (int x1,int y1,char *String,int MaxLen,int Curs_Pos,char Cursor) {
 char *Cursors[2]={"_",""};
 setcolor (WHITE);      setfillstyle (SOLID_FILL,0);
 setwritemode (COPY_PUT);
 bar (x1,y1,x1+8*(MaxLen+1),y1+12);
 outtextxy (x1,y1,String);
 setcolor (LIGHTCYAN);  setwritemode (XOR_PUT);
 outtextxy (x1+Curs_Pos*8,y1,Cursors[Cursor]);
}


void ncpy (char *In, char *From, int *Len) {
 int L=0; *In='\0';
 while (*(From+L)) { *(In+L)=*(From+L); L++; }
 *Len=L; return;
}

//////////////////////////////////////////////////////////////
//                      
//////////////////////////////////////////////////////////////

int MouseInit (void) {
 _AX=0;
 geninterrupt(0x33);
 if(_AX==0) return 0;
 else {
  /* 樠 pp ""  p᪮ p.
     "p祥" ⭮ -  p孨 㣮 pאַ㣮쭨 pp. */
  set_graph_cursor(0, 0 , ms_mask[0]);
  /* ⠭ p⨪  p⠫ p pp.
      ᥫ p.  - 8  16. */
//  hor_movement(0, 639);
//  vert_movement(0, 349);
  /* ⠭ pp  砫 : 3- p, 0- ⮫. */
  cur_state.hor_position= 300;
  cur_state.ver_position= 300;
  cur_state.buttons=0x00;
//  scor_mouse(8,8);
  ms_move(cur_state.hor_position,cur_state.ver_position);
  /* 祭 pp "". */
  CURSOR_ON();
  return 1;
 }
}

/* // ᫮ ᪠  
int ms_release(struct MOUSE_STATE * current_state) {
 struct REGPACK r;
 r.r_ax = 6;
 r.r_bx = current_state -> buttons;
 intr(0x33, &r);
 current_state -> hor_position = r.r_cx;
 current_state -> ver_position = r.r_dx;
 return r.r_bx;
}  */
/*
void scor_mouse(int scor_x,int scor_y) {
 _AX=0x000f;
 _CX=scor_x;
 _DX=scor_y;
 geninterrupt(0x33);
} */

/* p ﭨ  p ""  ⥪騥
  p pp. 頥 p  pp
  p  蠡 struct MOUSE_STATE. p 뢠
  窠 맮  p   㪠⥫.*/
void ms_state(struct MOUSE_STATE * current_state) {
 struct REGPACK r;
 r.r_ax = 3;
 intr(0x33, &r);
 current_state -> buttons = r.r_bx;
 current_state -> hor_position = r.r_cx;
 current_state -> ver_position = r.r_dx;
}

/*  p頥 pp ""    p. p
   ⥪⮢ p   p㠫 ᥫ, ..
  p ⥪⮢ p  ⮫ 㬭  8.*/

void ms_move(int hor_position, int ver_position) {
 _AX = 4;
 _CX = hor_position;
 _DX = ver_position;
 geninterrupt(0x33);
}

/*
void hor_movement(int start_hor_movement, int end_hor_movement){
  _AX = 7;
  _CX = start_hor_movement;
  _DX = end_hor_movement;
  geninterrupt(0x33);
}

void vert_movement(int start_vert_movement, int end_vert_movement){
  _AX = 8;
  _CX = start_vert_movement;
  _DX = end_vert_movement;
  geninterrupt(0x33);
}
*/

void set_graph_cursor(int hot_spot_column, int hot_spot_row,
                      unsigned int far * screen_and_cursor_masks) {
  struct REGPACK r;
  r.r_ax = 9;
  r.r_bx = hot_spot_column;
  r.r_cx = hot_spot_row;
  r.r_es = FP_SEG(screen_and_cursor_masks);
  r.r_dx = FP_OFF(screen_and_cursor_masks);
  intr(0x33, &r);
}

void ms_shape(struct MOUSE_STATE *current_state) {
 static int oldx,oldy;
 int i,x,y;
 x=current_state -> hor_position;
 y=current_state -> ver_position;
 Shape=SHAPEBARS;
 for (i=0; i<SHAPEBARS; i++) 
  if (x>ms_bar[i][0] && x<ms_bar[i][2] &&
      y>ms_bar[i][1] && y<ms_bar[i][3]) { Shape=i; break; }
 if (x==oldx && y==oldy) return;
 set_graph_cursor(0, 0 , ms_mask[Shape]);
 oldx=x; oldy=y;
}

int initEGA (void) {
 int Gd=EGA,Gm=1;
 registerbgidriver (EGAVGA_driver); 
 // COMPILE THIS FILE IN PROJECT WITH FILE EGAVGA.OBJ 
 // (It can be converted from egavga.bgi by usage program bgiobj.exe)
 initgraph (&Gd,&Gm,"");
 if (graphresult()!=grOk) {
  printf ("\nGraphics error:%s",grapherrormsg(graphresult()));
  return (0);
 }
 return (1);
}
